diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/channel-access-manager.cc ns-3.41/src/wifi/model/channel-access-manager.cc
--- ns-3.40/src/wifi/model/channel-access-manager.cc	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/channel-access-manager.cc	2024-02-09 14:44:08.577794800 -0800
@@ -20,6 +20,7 @@
 #include "channel-access-manager.h"
 
 #include "txop.h"
+#include "wifi-mac-queue.h"
 #include "wifi-phy-listener.h"
 #include "wifi-phy.h"
 
@@ -37,6 +38,8 @@
 
 NS_LOG_COMPONENT_DEFINE("ChannelAccessManager");
 
+NS_OBJECT_ENSURE_REGISTERED(ChannelAccessManager);
+
 /**
  * Listener for PHY events. Forwards to ChannelAccessManager.
  * The ChannelAccessManager may handle multiple PHY listeners connected to distinct PHYs,
@@ -168,6 +171,26 @@
  *      Implement the channel access manager of all Txop holders
  ****************************************************************/
 
+TypeId
+ChannelAccessManager::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::ChannelAccessManager")
+            .SetParent<ns3::Object>()
+            .SetGroupName("Wifi")
+            .AddConstructor<ChannelAccessManager>()
+            .AddAttribute("GenerateBackoffIfTxopWithoutTx",
+                          "Specify whether the backoff should be invoked when the AC gains the "
+                          "right to start a TXOP but it does not transmit any frame "
+                          "(e.g., due to constraints associated with EMLSR operations), "
+                          "provided that the queue is not actually empty.",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&ChannelAccessManager::SetGenerateBackoffOnNoTx,
+                                              &ChannelAccessManager::GetGenerateBackoffOnNoTx),
+                          MakeBooleanChecker());
+    return tid;
+}
+
 ChannelAccessManager::ChannelAccessManager()
     : m_lastAckTimeoutEnd(0),
       m_lastCtsTimeoutEnd(0),
@@ -177,7 +200,6 @@
       m_lastTxEnd(0),
       m_lastSwitchingEnd(0),
       m_usingOtherEmlsrLink(false),
-      m_lastUsingOtherEmlsrLinkEnd(0),
       m_sleeping(false),
       m_off(false),
       m_linkId(0)
@@ -212,12 +234,12 @@
     m_phyListeners.clear();
 }
 
-PhyListener*
+std::shared_ptr<PhyListener>
 ChannelAccessManager::GetPhyListener(Ptr<WifiPhy> phy) const
 {
     if (auto listenerIt = m_phyListeners.find(phy); listenerIt != m_phyListeners.end())
     {
-        return listenerIt->second.get();
+        return listenerIt->second;
     }
     return nullptr;
 }
@@ -227,9 +249,7 @@
 {
     NS_LOG_FUNCTION(this << phy);
 
-    auto phyListener = GetPhyListener(phy);
-
-    if (phyListener)
+    if (auto phyListener = GetPhyListener(phy))
     {
         // a PHY listener for the given PHY already exists, it must be inactive
         NS_ASSERT_MSG(!phyListener->IsActive(),
@@ -239,7 +259,7 @@
     }
     else
     {
-        phyListener = new PhyListener(this);
+        phyListener = std::make_shared<PhyListener>(this);
         m_phyListeners.emplace(phy, phyListener);
         phy->RegisterListener(phyListener);
     }
@@ -393,12 +413,15 @@
 }
 
 bool
-ChannelAccessManager::NeedBackoffUponAccess(Ptr<Txop> txop)
-{
-    NS_LOG_FUNCTION(this << txop);
-
-    // No backoff needed if in sleep mode, off or when using another EMLSR link
-    if (m_sleeping || m_off || m_usingOtherEmlsrLink)
+ChannelAccessManager::NeedBackoffUponAccess(Ptr<Txop> txop,
+                                            bool hadFramesToTransmit,
+                                            bool checkMediumBusy)
+{
+    NS_LOG_FUNCTION(this << txop << hadFramesToTransmit << checkMediumBusy);
+
+    // No backoff needed if in sleep mode or off. Checking if m_phy is nullptr is a workaround
+    // needed for EMLSR and may be removed in the future
+    if (m_sleeping || m_off || !m_phy)
     {
         return false;
     }
@@ -426,10 +449,10 @@
      *    with that AC has now become non-empty and any other transmit queues
      *    associated with that AC are empty; the medium is busy on the primary channel
      */
-    if (!txop->HasFramesToTransmit(m_linkId) && txop->GetAccessStatus(m_linkId) != Txop::GRANTED &&
-        txop->GetBackoffSlots(m_linkId) == 0)
+    if (!hadFramesToTransmit && txop->HasFramesToTransmit(m_linkId) &&
+        txop->GetAccessStatus(m_linkId) != Txop::GRANTED && txop->GetBackoffSlots(m_linkId) == 0)
     {
-        if (!IsBusy())
+        if (checkMediumBusy && !IsBusy())
         {
             // medium idle. If this is a DCF, use immediate access (we can transmit
             // in a DIFS if the medium remains idle). If this is an EDCAF, update
@@ -453,17 +476,13 @@
 ChannelAccessManager::RequestAccess(Ptr<Txop> txop)
 {
     NS_LOG_FUNCTION(this << txop);
-    if (m_phy)
+    if (m_phy && txop->HasFramesToTransmit(m_linkId))
     {
         m_phy->NotifyChannelAccessRequested();
     }
-    if (m_usingOtherEmlsrLink)
-    {
-        NS_LOG_DEBUG("Channel access cannot be requested while using another EMLSR link");
-        return;
-    }
-    // Deny access if in sleep mode or off
-    if (m_sleeping || m_off)
+    // Deny access if in sleep mode or off. Checking if m_phy is nullptr is a workaround
+    // needed for EMLSR and may be removed in the future
+    if (m_sleeping || m_off || !m_phy)
     {
         return;
     }
@@ -558,6 +577,9 @@
             }
             else
             {
+                // this TXOP did not transmit anything, make sure that backoff counter starts
+                // decreasing in a slot again
+                txop->UpdateBackoffSlotsNow(0, now, m_linkId);
                 // reset the current state to the EDCAF that won the contention
                 // but did not transmit anything
                 i--;
@@ -595,8 +617,6 @@
     Time ackTimeoutAccessStart = m_lastAckTimeoutEnd + sifs;
     Time ctsTimeoutAccessStart = m_lastCtsTimeoutEnd + sifs;
     Time switchingAccessStart = m_lastSwitchingEnd + sifs;
-    Time usingOtherEmlsrLinkAccessStart =
-        (m_usingOtherEmlsrLink ? Simulator::Now() : m_lastUsingOtherEmlsrLinkEnd) + sifs;
     Time accessGrantedStart;
     if (ignoreNav)
     {
@@ -605,7 +625,6 @@
                                        txAccessStart,
                                        ackTimeoutAccessStart,
                                        ctsTimeoutAccessStart,
-                                       usingOtherEmlsrLinkAccessStart,
                                        switchingAccessStart});
     }
     else
@@ -616,18 +635,15 @@
                                        navAccessStart,
                                        ackTimeoutAccessStart,
                                        ctsTimeoutAccessStart,
-                                       usingOtherEmlsrLinkAccessStart,
                                        switchingAccessStart});
     }
-    std::stringstream ss;
-    if (m_usingOtherEmlsrLink)
-    {
-        ss << ", using other EMLSR link access start=" << usingOtherEmlsrLinkAccessStart;
-    }
-    NS_LOG_INFO("access grant start=" << accessGrantedStart << ", rx access start=" << rxAccessStart
-                                      << ", busy access start=" << busyAccessStart
-                                      << ", tx access start=" << txAccessStart
-                                      << ", nav access start=" << navAccessStart << ss.str());
+    NS_LOG_INFO("access grant start=" << accessGrantedStart.As(Time::US)
+                                      << ", rx access start=" << rxAccessStart.As(Time::US)
+                                      << ", busy access start=" << busyAccessStart.As(Time::US)
+                                      << ", tx access start=" << txAccessStart.As(Time::US)
+                                      << ", nav access start=" << navAccessStart.As(Time::US)
+                                      << ", switching access start="
+                                      << switchingAccessStart.As(Time::US));
     return accessGrantedStart;
 }
 
@@ -638,7 +654,8 @@
     Time mostRecentEvent =
         std::max({txop->GetBackoffStart(m_linkId),
                   GetAccessGrantStart() + (txop->GetAifsn(m_linkId) * GetSlot())});
-    NS_LOG_DEBUG("Backoff start: " << mostRecentEvent.As(Time::US));
+    NS_LOG_DEBUG("Backoff start for " << txop->GetWifiMacQueue()->GetAc() << ": "
+                                      << mostRecentEvent.As(Time::US));
 
     return mostRecentEvent;
 }
@@ -648,7 +665,8 @@
 {
     NS_LOG_FUNCTION(this << txop);
     Time backoffEnd = GetBackoffStartFor(txop) + (txop->GetBackoffSlots(m_linkId) * GetSlot());
-    NS_LOG_DEBUG("Backoff end: " << backoffEnd.As(Time::US));
+    NS_LOG_DEBUG("Backoff end for " << txop->GetWifiMacQueue()->GetAc() << ": "
+                                    << backoffEnd.As(Time::US));
 
     return backoffEnd;
 }
@@ -802,6 +820,19 @@
 }
 
 void
+ChannelAccessManager::SetGenerateBackoffOnNoTx(bool enable)
+{
+    NS_LOG_FUNCTION(this << enable);
+    m_generateBackoffOnNoTx = enable;
+}
+
+bool
+ChannelAccessManager::GetGenerateBackoffOnNoTx() const
+{
+    return m_generateBackoffOnNoTx;
+}
+
+void
 ChannelAccessManager::NotifyRxStartNow(Time duration)
 {
     NS_LOG_FUNCTION(this << duration);
@@ -967,6 +998,18 @@
 }
 
 void
+ChannelAccessManager::ResetAllBackoffs()
+{
+    NS_LOG_FUNCTION(this);
+
+    for (const auto& txop : m_txops)
+    {
+        ResetBackoff(txop);
+    }
+    m_accessTimeout.Cancel();
+}
+
+void
 ChannelAccessManager::NotifySleepNow()
 {
     NS_LOG_FUNCTION(this);
@@ -1030,6 +1073,14 @@
 ChannelAccessManager::NotifyNavResetNow(Time duration)
 {
     NS_LOG_FUNCTION(this << duration);
+
+    if (!m_phy)
+    {
+        NS_LOG_DEBUG("Do not reset NAV, CTS may have been missed due to the main PHY switching "
+                     "to another link to take over a TXOP while receiving the CTS");
+        return;
+    }
+
     NS_LOG_DEBUG("nav reset for=" << duration);
     UpdateBackoff();
     m_lastNavEnd = Simulator::Now() + duration;
@@ -1086,18 +1137,7 @@
 ChannelAccessManager::NotifyStartUsingOtherEmlsrLink()
 {
     NS_LOG_FUNCTION(this);
-    // update backoff if a PHY is operating on this link
-    if (m_phy)
-    {
-        UpdateBackoff();
-    }
-    // Cancel timeout
-    if (m_accessTimeout.IsRunning())
-    {
-        m_accessTimeout.Cancel();
-    }
     m_usingOtherEmlsrLink = true;
-    UpdateLastIdlePeriod();
 }
 
 void
@@ -1105,16 +1145,13 @@
 {
     NS_LOG_FUNCTION(this);
     m_usingOtherEmlsrLink = false;
-    m_lastUsingOtherEmlsrLinkEnd = Simulator::Now();
-    DoRestartAccessTimeoutIfNeeded();
 }
 
 void
 ChannelAccessManager::UpdateLastIdlePeriod()
 {
     NS_LOG_FUNCTION(this);
-    Time idleStart =
-        std::max({m_lastTxEnd, m_lastRx.end, m_lastSwitchingEnd, m_lastUsingOtherEmlsrLinkEnd});
+    Time idleStart = std::max({m_lastTxEnd, m_lastRx.end, m_lastSwitchingEnd});
     Time now = Simulator::Now();
 
     if (idleStart >= now)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/channel-access-manager.h ns-3.41/src/wifi/model/channel-access-manager.h
--- ns-3.40/src/wifi/model/channel-access-manager.h	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/channel-access-manager.h	2024-02-09 14:44:08.577794800 -0800
@@ -33,6 +33,8 @@
 #include <unordered_map>
 #include <vector>
 
+class EmlsrUlTxopTest;
+
 namespace ns3
 {
 
@@ -58,11 +60,20 @@
  */
 class ChannelAccessManager : public Object
 {
+    /// Allow test cases to access private members
+    friend class ::EmlsrUlTxopTest;
+
   public:
     ChannelAccessManager();
     ~ChannelAccessManager() override;
 
     /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    /**
      * Set up (or reactivate) listener for PHY events on the given PHY. The new (or reactivated)
      * listener becomes the active listener and the previous active listener attached to another
      * PHY, if any, is deactivated.
@@ -109,13 +120,22 @@
     void Add(Ptr<Txop> txop);
 
     /**
-     * Determine if a new backoff needs to be generated when a packet is queued
-     * for transmission.
+     * Determine if a new backoff needs to be generated as per letter a) of Section 10.23.2.2
+     * of IEEE 802.11-2020 ("EDCA backoff procedure"). This method is called upon the occurrence
+     * of events such as the enqueuing of a packet or the unblocking of some links after they
+     * have been blocked for some reason (e.g., wait for ADDBA Response, wait for TX on another
+     * EMLSR link to finish, etc.). The <i>checkMediumBusy</i> argument allows to generate a new
+     * backoff regardless of the busy/idle state of the medium, as per Section 35.3.16.4 of
+     * 802.11be D4.0.
      *
      * \param txop the Txop requesting to generate a backoff
+     * \param hadFramesToTransmit whether packets available for transmission were queued just
+     *                            before the occurrence of the event triggering this call
+     * \param checkMediumBusy whether generation of backoff (also) depends on the busy/idle state
+     *                        of the medium
      * \return true if backoff needs to be generated, false otherwise
      */
-    bool NeedBackoffUponAccess(Ptr<Txop> txop);
+    bool NeedBackoffUponAccess(Ptr<Txop> txop, bool hadFramesToTransmit, bool checkMediumBusy);
 
     /**
      * \param txop a Txop
@@ -149,6 +169,22 @@
     void DisableEdcaFor(Ptr<Txop> qosTxop, Time duration);
 
     /**
+     * Set the member variable indicating whether the backoff should be invoked when an AC gains
+     * the right to start a TXOP but it does not transmit any frame (e.g., due to constraints
+     * associated with EMLSR operations), provided that the queue is not actually empty.
+     *
+     * \param enable whether to enable backoff generation when no TX is performed in a TXOP
+     */
+    void SetGenerateBackoffOnNoTx(bool enable);
+
+    /**
+     * \return whether the backoff should be invoked when an AC gains the right to start a TXOP
+     *         but it does not transmit any frame (e.g., due to constraints associated with EMLSR
+     *         operations), provided that the queue is not actually empty
+     */
+    bool GetGenerateBackoffOnNoTx() const;
+
+    /**
      * Return the width of the largest primary channel that has been idle for the
      * given time interval before the given time, if any primary channel has been
      * idle, or zero, otherwise.
@@ -294,6 +330,11 @@
     void ResetBackoff(Ptr<Txop> txop);
 
     /**
+     * Reset the backoff for all the DCF/EDCAF. Additionally, cancel the access timeout event.
+     */
+    void ResetAllBackoffs();
+
+    /**
      * Notify that the given PHY is about to switch to the given operating channel, which is
      * used by the given link. This notification is sent by the EMLSR Manager when a PHY object
      * switches operating channel to operate on another link.
@@ -317,7 +358,7 @@
      * \param phy the given PHY
      * \return the current registered listener for PHY events on the given PHY
      */
-    PhyListener* GetPhyListener(Ptr<WifiPhy> phy) const;
+    std::shared_ptr<PhyListener> GetPhyListener(Ptr<WifiPhy> phy) const;
     /**
      * Initialize the structures holding busy end times per channel type (primary,
      * secondary, etc.) and per 20 MHz channel.
@@ -413,15 +454,17 @@
     std::vector<Time> m_lastPer20MHzBusyEnd; /**< the last busy end time per 20 MHz channel
                                                   (HE stations and channel width > 20 MHz only) */
     std::map<WifiChannelListType, Timespan>
-        m_lastIdle;                    //!< the last idle start and end time for each channel type
-    Time m_lastSwitchingEnd;           //!< the last switching end time
-    bool m_usingOtherEmlsrLink;        //!< whether another EMLSR link is being used
-    Time m_lastUsingOtherEmlsrLinkEnd; //!< the last time we were blocked because using another
-                                       //!< EMLSR link
-    bool m_sleeping;                   //!< flag whether it is in sleeping state
-    bool m_off;                        //!< flag whether it is in off state
-    Time m_eifsNoDifs;                 //!< EIFS no DIFS time
-    EventId m_accessTimeout;           //!< the access timeout ID
+        m_lastIdle;               //!< the last idle start and end time for each channel type
+    Time m_lastSwitchingEnd;      //!< the last switching end time
+    bool m_usingOtherEmlsrLink;   //!< whether another EMLSR link is being used
+    bool m_sleeping;              //!< flag whether it is in sleeping state
+    bool m_off;                   //!< flag whether it is in off state
+    Time m_eifsNoDifs;            //!< EIFS no DIFS time
+    EventId m_accessTimeout;      //!< the access timeout ID
+    bool m_generateBackoffOnNoTx; //!< whether the backoff should be invoked when the AC gains the
+                                  //!< right to start a TXOP but it does not transmit any frame
+                                  //!< (e.g., due to constraints associated with EMLSR operations),
+                                  //!< provided that the queue is not actually empty
 
     /// Information associated with each PHY that is going to operate on another EMLSR link
     struct EmlsrLinkSwitchInfo
@@ -434,7 +477,7 @@
     std::unordered_map<Ptr<WifiPhy>, EmlsrLinkSwitchInfo> m_switchingEmlsrLinks;
 
     /// Maps each PHY listener to the associated PHY
-    using PhyListenerMap = std::unordered_map<Ptr<WifiPhy>, std::unique_ptr<PhyListener>>;
+    using PhyListenerMap = std::unordered_map<Ptr<WifiPhy>, std::shared_ptr<PhyListener>>;
 
     PhyListenerMap m_phyListeners;         //!< the PHY listeners
     Ptr<WifiPhy> m_phy;                    //!< pointer to the unique active PHY
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/ctrl-headers.cc ns-3.41/src/wifi/model/ctrl-headers.cc
--- ns-3.40/src/wifi/model/ctrl-headers.cc	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/ctrl-headers.cc	2024-02-09 14:44:08.577794800 -0800
@@ -719,14 +719,27 @@
 
     uint16_t ret = (m_baInfo[index].m_startingSeq << 4) & 0xfff0;
 
-    // The Fragment Number subfield encodes the length of the bitmap for
-    // Compressed and Multi-STA variants (see sections 9.3.1.9.3 and 9.3.1.9.7
-    // of 802.11ax Draft 3.0). Note that Fragmentation Level 3 is not supported.
+    // The Fragment Number subfield encodes the length of the bitmap for Compressed and Multi-STA
+    // variants (see sections 9.3.1.8.2 and 9.3.1.8.7 of 802.11ax-2021 and 802.11be Draft 4.0).
+    // Note that Fragmentation Level 3 is not supported.
     if (m_baType.m_variant == BlockAckType::COMPRESSED)
     {
-        if (m_baType.m_bitmapLen[0] == 32)
+        switch (m_baType.m_bitmapLen[0])
         {
+        case 8:
+            // do nothing
+            break;
+        case 32:
             ret |= 0x0004;
+            break;
+        case 64:
+            ret |= 0x0008;
+            break;
+        case 128:
+            ret |= 0x000a;
+            break;
+        default:
+            NS_ABORT_MSG("Unsupported bitmap length: " << +m_baType.m_bitmapLen[0] << " bytes");
         }
     }
     else if (m_baType.m_variant == BlockAckType::MULTI_STA)
@@ -735,17 +748,28 @@
         NS_ASSERT_MSG(!m_baInfo[index].m_bitmap.empty(),
                       "This Per AID TID Info subfield has no Starting Sequence Control subfield");
 
-        if (m_baType.m_bitmapLen[index] == 16)
+        switch (m_baType.m_bitmapLen[index])
         {
+        case 8:
+            // do nothing
+            break;
+        case 16:
             ret |= 0x0002;
-        }
-        else if (m_baType.m_bitmapLen[index] == 32)
-        {
+            break;
+        case 32:
             ret |= 0x0004;
-        }
-        else if (m_baType.m_bitmapLen[index] == 4)
-        {
+            break;
+        case 4:
             ret |= 0x0006;
+            break;
+        case 64:
+            ret |= 0x0008;
+            break;
+        case 128:
+            ret |= 0x000a;
+            break;
+        default:
+            NS_ABORT_MSG("Unsupported bitmap length: " << +m_baType.m_bitmapLen[index] << " bytes");
         }
     }
     return ret;
@@ -758,54 +782,66 @@
                   "index can only be non null for Multi-STA Block Ack");
     NS_ASSERT(index < m_baInfo.size());
 
-    // The Fragment Number subfield encodes the length of the bitmap for
-    // Compressed and Multi-STA variants (see sections 9.3.1.9.3 and 9.3.1.9.7
-    // of 802.11ax Draft 3.0). Note that Fragmentation Level 3 is not supported.
+    // The Fragment Number subfield encodes the length of the bitmap for Compressed and Multi-STA
+    // variants (see sections 9.3.1.8.2 and 9.3.1.8.7 of 802.11ax-2021 and 802.11be Draft 4.0).
+    // Note that Fragmentation Level 3 is not supported.
     if (m_baType.m_variant == BlockAckType::COMPRESSED)
     {
-        if ((seqControl & 0x0001) == 1)
+        uint16_t fragNumber = seqControl & 0x000f;
+
+        if ((fragNumber & 0x0001) == 1)
         {
             NS_FATAL_ERROR("Fragmentation Level 3 unsupported");
         }
-        if (((seqControl >> 3) & 0x0001) == 0 && ((seqControl >> 1) & 0x0003) == 0)
+        switch (fragNumber)
         {
+        case 0:
             SetType({BlockAckType::COMPRESSED, {8}});
-        }
-        else if (((seqControl >> 3) & 0x0001) == 0 && ((seqControl >> 1) & 0x0003) == 2)
-        {
+            break;
+        case 4:
             SetType({BlockAckType::COMPRESSED, {32}});
-        }
-        else
-        {
-            NS_FATAL_ERROR("Reserved configurations");
+            break;
+        case 8:
+            SetType({BlockAckType::COMPRESSED, {64}});
+            break;
+        case 10:
+            SetType({BlockAckType::COMPRESSED, {128}});
+            break;
+        default:
+            NS_ABORT_MSG("Unsupported fragment number: " << fragNumber);
         }
     }
     else if (m_baType.m_variant == BlockAckType::MULTI_STA)
     {
-        if ((seqControl & 0x0001) == 1)
+        uint16_t fragNumber = seqControl & 0x000f;
+
+        if ((fragNumber & 0x0001) == 1)
         {
             NS_FATAL_ERROR("Fragmentation Level 3 unsupported");
         }
         uint8_t bitmapLen = 0;
-        if (((seqControl >> 3) & 0x0001) == 0 && ((seqControl >> 1) & 0x0003) == 0)
+        switch (fragNumber)
         {
+        case 0:
             bitmapLen = 8;
-        }
-        else if (((seqControl >> 3) & 0x0001) == 0 && ((seqControl >> 1) & 0x0003) == 1)
-        {
+            break;
+        case 2:
             bitmapLen = 16;
-        }
-        else if (((seqControl >> 3) & 0x0001) == 0 && ((seqControl >> 1) & 0x0003) == 2)
-        {
+            break;
+        case 4:
             bitmapLen = 32;
-        }
-        else if (((seqControl >> 3) & 0x0001) == 0 && ((seqControl >> 1) & 0x0003) == 3)
-        {
+            break;
+        case 6:
             bitmapLen = 4;
-        }
-        else
-        {
-            NS_FATAL_ERROR("Reserved configurations");
+            break;
+        case 8:
+            bitmapLen = 64;
+            break;
+        case 10:
+            bitmapLen = 128;
+            break;
+        default:
+            NS_ABORT_MSG("Unsupported fragment number: " << fragNumber);
         }
         m_baType.m_bitmapLen[index] = bitmapLen;
         m_baInfo[index].m_bitmap.assign(bitmapLen, 0);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/eht/default-emlsr-manager.cc ns-3.41/src/wifi/model/eht/default-emlsr-manager.cc
--- ns-3.40/src/wifi/model/eht/default-emlsr-manager.cc	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/eht/default-emlsr-manager.cc	2024-02-09 14:44:08.581795000 -0800
@@ -23,6 +23,7 @@
 #include "ns3/channel-access-manager.h"
 #include "ns3/log.h"
 #include "ns3/wifi-mpdu.h"
+#include "ns3/wifi-net-device.h"
 #include "ns3/wifi-phy.h"
 
 namespace ns3
@@ -42,7 +43,10 @@
             .AddConstructor<DefaultEmlsrManager>()
             .AddAttribute("SwitchAuxPhy",
                           "Whether Aux PHY should switch channel to operate on the link on which "
-                          "the Main PHY was operating before moving to the link of the Aux PHY.",
+                          "the Main PHY was operating before moving to the link of the Aux PHY. "
+                          "Note that, if the Aux PHY does not switch channel, the main PHY will "
+                          "switch back to its previous link once the TXOP terminates (otherwise, "
+                          "no PHY will be listening on that EMLSR link).",
                           BooleanValue(true),
                           MakeBooleanAccessor(&DefaultEmlsrManager::m_switchAuxPhy),
                           MakeBooleanChecker());
@@ -94,25 +98,79 @@
 {
     NS_LOG_FUNCTION(this << currLinkId << nextLinkId);
 
-    if (!m_switchAuxPhy)
+    if (m_switchAuxPhy)
     {
-        return; // nothing to do
+        // switch channel on Aux PHY so that it operates on the link on which the main PHY was
+        // operating
+        SwitchAuxPhy(nextLinkId, currLinkId);
+        return;
     }
 
-    // switch channel on Aux PHY so that it operates on the link on which the main PHY was operating
-    auto auxPhy = GetStaMac()->GetWifiPhy(nextLinkId);
+    if (currLinkId != GetMainPhyId())
+    {
+        // the main PHY is leaving a non-primary link, hence an aux PHY needs to be reconnected
+        NS_ASSERT_MSG(
+            m_auxPhyToReconnect,
+            "There should be an aux PHY to reconnect when the main PHY leaves a non-primary link");
+
+        // the Aux PHY is not actually switching (hence no switching delay)
+        GetStaMac()->NotifySwitchingEmlsrLink(m_auxPhyToReconnect, currLinkId, Seconds(0));
+        SetCcaEdThresholdOnLinkSwitch(m_auxPhyToReconnect, currLinkId);
+        m_auxPhyToReconnect = nullptr;
+    }
 
-    auto newAuxPhyChannel = GetChannelForAuxPhy(currLinkId);
+    if (nextLinkId != GetMainPhyId())
+    {
+        // the main PHY is moving to a non-primary link and the aux PHY does not switch link
+        m_auxPhyToReconnect = GetStaMac()->GetWifiPhy(nextLinkId);
+    }
+}
 
-    NS_LOG_DEBUG("Aux PHY (" << auxPhy << ") is about to switch to " << newAuxPhyChannel
-                             << " to operate on link " << +currLinkId);
+void
+DefaultEmlsrManager::DoNotifyIcfReceived(uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << linkId);
+}
 
-    GetStaMac()
-        ->GetChannelAccessManager(nextLinkId)
-        ->NotifySwitchingEmlsrLink(auxPhy, newAuxPhyChannel, currLinkId);
+void
+DefaultEmlsrManager::DoNotifyUlTxopStart(uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << linkId);
+}
+
+void
+DefaultEmlsrManager::DoNotifyTxopEnd(uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << linkId);
+
+    // switch main PHY to the previous link, if needed
+    if (!m_switchAuxPhy && m_auxPhyToReconnect)
+    {
+        auto mainPhy = GetStaMac()->GetDevice()->GetPhy(m_mainPhyId);
 
-    void (WifiPhy::*fp)(const WifiPhyOperatingChannel&) = &WifiPhy::SetOperatingChannel;
-    Simulator::ScheduleNow(fp, auxPhy, newAuxPhyChannel);
+        // the main PHY may be switching at the end of a TXOP when, e.g., the main PHY starts
+        // switching to a link on which an aux PHY gained a TXOP and sent an RTS, but the CTS
+        // is not received and the UL TXOP ends before the main PHY channel switch is completed.
+        // In such cases, wait until the main PHY channel switch is completed before requesting
+        // a new channel switch.
+        // Backoff shall not be reset on the link left by the main PHY because a TXOP ended and
+        // a new backoff value must be generated.
+        if (!mainPhy->IsStateSwitching())
+        {
+            SwitchMainPhy(GetMainPhyId(), false, DONT_RESET_BACKOFF, REQUEST_ACCESS);
+        }
+        else
+        {
+            Simulator::Schedule(mainPhy->GetDelayUntilIdle(),
+                                &DefaultEmlsrManager::SwitchMainPhy,
+                                this,
+                                GetMainPhyId(),
+                                false,
+                                DONT_RESET_BACKOFF,
+                                REQUEST_ACCESS);
+        }
+        return;
+    }
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/eht/default-emlsr-manager.h ns-3.41/src/wifi/model/eht/default-emlsr-manager.h
--- ns-3.40/src/wifi/model/eht/default-emlsr-manager.h	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/eht/default-emlsr-manager.h	2024-02-09 14:44:08.581795000 -0800
@@ -52,9 +52,15 @@
     void DoNotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId) override;
     void NotifyEmlsrModeChanged() override;
     void NotifyMainPhySwitch(uint8_t currLinkId, uint8_t nextLinkId) override;
+    void DoNotifyIcfReceived(uint8_t linkId) override;
+    void DoNotifyUlTxopStart(uint8_t linkId) override;
+    void DoNotifyTxopEnd(uint8_t linkId) override;
 
     bool m_switchAuxPhy; /**< whether Aux PHY should switch channel to operate on the link on which
                               the Main PHY was operating before moving to the link of the Aux PHY */
+    Ptr<WifiPhy> m_auxPhyToReconnect; //!< Aux PHY the ChannelAccessManager of the link on which
+                                      //!< the main PHY is operating has to connect a listener to
+                                      //!< when the main PHY is back operating on its previous link
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/eht/eht-capabilities.h ns-3.41/src/wifi/model/eht/eht-capabilities.h
--- ns-3.40/src/wifi/model/eht/eht-capabilities.h	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/eht/eht-capabilities.h	2024-02-09 14:44:08.581795000 -0800
@@ -273,7 +273,7 @@
     /**
      * Set the maximum A-MPDU length.
      *
-     * \param maxAmpduLength 2^(23 + x) - 1, x in the range 0 to 3
+     * \param maxAmpduLength 2^(23 + x) - 1, x in the range 0 to 1
      */
     void SetMaxAmpduLength(uint32_t maxAmpduLength);
 
